package cz.mendelu.dnaAnalyser.analyse.cpg;

import cz.mendelu.dnaAnalyser.overlay.LocalisedOverlay;
import cz.mendelu.dnaAnalyser.utils.analyse.service.AbstractDataSessionService;
import cz.mendelu.dnaAnalyser.utils.analyse.service.heatmap.HeatmapService;
import org.apache.ibatis.session.Configuration;
import org.springframework.stereotype.Service;

import java.sql.SQLException;
import java.sql.Statement;

@Service
public class CpgDataSessionService extends AbstractDataSessionService implements HeatmapService, LocalisedOverlay {

    @Override
    protected void onCreateTables(Statement statement) throws SQLException {
        // Predpokladá sa, že CpgMapper obsahuje SQL príkaz pre vytvorenie tabuľky pre CpG analýzy
        statement.execute(CpgMapper.TABLE);
    }

    @Override
    protected void onConfiguration(Configuration configuration) {
        // Registrácia aliasu a mappera pre CpG analýzu
        configuration.getTypeAliasRegistry().registerAlias(Cpg.class);
        configuration.addMapper(CpgMapper.class);
    }
}
