package cz.mendelu.dnaAnalyser.sequence.annotation.feature;


import cz.mendelu.dnaAnalyser.overlay.AnalyseResult;
import lombok.*;

@Data
@NoArgsConstructor
@AllArgsConstructor
public class Feature {

    @NonNull
    private Long id;
    @NonNull
    private String featureType;
    @NonNull
    private String startPosition;
    @NonNull
    private String endPosition;
    @NonNull
    private String annotation;

    private Integer areaSize;

    private Integer middle;

    private Integer after;

    private Integer before;

    public Feature(Long id, @NonNull String featureType, @NonNull String startPosition, @NonNull String endPosition, String annotation) {
        this.id = id;
        this.featureType = featureType;
        this.startPosition = startPosition;
        this.endPosition = endPosition;
        this.annotation = annotation;

    }

    public Feature(@NonNull String featureType, @NonNull String startPosition, @NonNull String endPosition, Integer areaSize) {
        this.featureType = featureType;
        this.startPosition = startPosition;
        this.endPosition = endPosition;
        this.areaSize = areaSize;
        this.middle = (Integer.parseInt(this.startPosition) +  Integer.parseInt(this.endPosition)) / 2;
        this.after = Integer.parseInt(this.endPosition) + areaSize;
        this.before = Integer.parseInt(this.startPosition) > areaSize ? Integer.parseInt(this.startPosition) - areaSize : 0;

    }

    public boolean isIn(AnalyseResult analyse){
        return (Integer.parseInt(this.startPosition) <= analyse.getMiddle() && analyse.getMiddle() <= Integer.parseInt(this.endPosition));
    }
    public boolean isBefore(AnalyseResult analyse){
        return (this.before <= analyse.getMiddle() && analyse.getMiddle() <= (Integer.parseInt(this.startPosition)));
    }
    public boolean isAfter(AnalyseResult analyse){
        return (Integer.parseInt(this.endPosition) <= analyse.getMiddle() && analyse.getMiddle() <= this.after);
    }

}