package cz.mendelu.dnaAnalyser.sequence

import cz.mendelu.dnaAnalyser.sequence.model.TestNucleicBuffer
import spock.lang.Ignore
import spock.lang.Specification

class NucleotideBufferTest extends Specification {

    @Ignore
    def "test mismatches same"() {
        given:
        def a = new TestNucleicBuffer("ACTGACTG")
        def b = new TestNucleicBuffer("ACTGACTG")

        when:
        def mismatches = a.mismatches(b)

        then:
        mismatches == 0
    }

    @Ignore
    def "test mismatches with one mistake"() {
        given:
        def a = new TestNucleicBuffer("ACTGACTG")
        def b = new TestNucleicBuffer("ACTNACTG")

        when:
        def mismatches = a.mismatches(b)

        then:
        mismatches == 1
    }

    def "test mismatches with different boarders"() {
        given:
        def a = new TestNucleicBuffer("ACTGACTG")
        def b = new TestNucleicBuffer("NCTNACTG")

        when:
        def mismatches = a.mismatches(b)

        then:
        mismatches == null
    }

    def "test mismatches with different length"() {
        given:
        def a = new TestNucleicBuffer("ACTGACTG")
        def b = new TestNucleicBuffer("NCTNACT")

        when:
        a.mismatches(b)

        then:
        thrown(IllegalArgumentException)
    }


}
