package cz.mendelu.dnaAnalyser.utils.analyse.service;

import cz.mendelu.dnaAnalyser.utils.analyse.data.TestData;
import cz.mendelu.dnaAnalyser.utils.analyse.data.TestDataMapper;
import org.apache.ibatis.session.Configuration;

import javax.sql.DataSource;
import java.sql.SQLException;
import java.sql.Statement;

public class TestDataSessionService extends AbstractDataSessionService {

    private String jdbcUrl;

    public void setJdbcUrl(String jdbcUrl) {
        this.jdbcUrl = jdbcUrl;
    }

    public void setDatasourceUrl(String datasourceUrl) {
        super.datasourceUrl = datasourceUrl;
    }

    public void setDatasourceUsername(String datasourceUsername) {
        super.datasourceUsername = datasourceUsername;
    }

    public void setDatasourcePassword(String datasourcePassword) {
        super.datasourcePassword = datasourcePassword;
    }

    public void setDatasourceDriverClassName(String datasourceDriverClassName) {
        super.datasourceDriverClassName = datasourceDriverClassName;
    }

    @Override
    protected DataSource createDataSource(String jdbcUrl) {
        if (this.jdbcUrl == null) {
            return super.createDataSource(jdbcUrl);
        }
        return super.createDataSource(this.jdbcUrl);
    }

    boolean onCreateTables_called = false;

    @Override
    protected void onCreateTables(Statement statement) throws SQLException {
        onCreateTables_called = true;
        statement.execute(TestDataMapper.TABLE);
    }

    boolean onConfiguration_called = false;

    @Override
    protected void onConfiguration(Configuration configuration) {
        onConfiguration_called = true;
        configuration.getTypeAliasRegistry().registerAlias(TestData.class);
        configuration.addMapper(TestDataMapper.class);
    }

    void resetOnCallMarkers() {
        onConfiguration_called = false;
        onCreateTables_called = false;
    }
}